<?php
if (!defined('PYROSYS')) {
	exit('Erreur PyRoSys N°01: Accès refusé => Vous ne pouvez accéder directement à cette page!');
}
?>

<h1>Connaissances PHP/(x)HTML/CSS/MySQL</h1>
<hr />
<p>Au niveau de la programmation web. Les bases sont selon-moi la mise en relation des langages PHP, (x)HTML, CSS et MySQL.<br />
La plupart des sites internet que l'on utilise régulièrement sont créés sur ce principe.<br />
<br />
Dans tous cas, c'est ce model que j'utilise. Ce Portfolio respect d'ailleurs ce principe.<br />
Les éléments sont positionnés en xHTML 1.0 Strict (Normes W3C) et la mise en forme est faite à l'aide du CSS 2.0.<br />
Le site internet est généré dynamiquement à l'aide du PHP (système de pages, de templates, de langues) et le contenu des différentes pages sont restituées depuis MySQL.</p>

<h3>Code Source de mon Portfolio</h3>
<p>La totalité des codes de ce site ont été créer avec mes propres connaissances ainsi que les éléments graphiques (à l'exception de GeSHi, JQuery et Highslide).<br />
Je vous propose de télécharger les codes sources que j'ai placé sous license <a href="http://creativecommons.org/licenses/by-nc/2.0/fr/">Creative Commons Paternité - Pas d'Utilisation Commerciale</a>.<br />
Vous pourrez ainsi juger de la qualité de mon travail:</p>
<p class="download">
	<a rel="download" href="ressources/pyroxty-portfolio_rev001-alpha.zip" title="Sources PyRoXtY Portfolio">
		<img alt="Télécharger" src="images/download.png" /><br />
		TELECHARGER LE CODE SOURCE DE MON PORTFOLIO
	</a><br />
	<br />
	<a rel="license" href="http://creativecommons.org/licenses/by-nc/2.0/fr/">
		<img alt="Licence Creative Commons" style="border-width:0" src="http://i.creativecommons.org/l/by-nc/2.0/fr/88x31.png" />
	</a>
	<br />Ce(tte) oeuvre est mise à disposition selon les termes de la <a rel="license" href="http://creativecommons.org/licenses/by-nc/2.0/fr/">Licence Creative Commons Paternité - Pas d&#39;Utilisation Commerciale 2.0 France</a>.
</p>

<h3>Fonction de simplification des actions sur base de donnée MySQL:</h3>
<p>La prochaine amélioration de mon portfolio portera sur une gestion complète par MySQL.<br />
Voici un exemple de fonctions qui seront utilisées sur cette prochaine version.<br />
<br />Exemple d'appel (index.php):</p>
<?php
include_once('includes/geshi/geshi.php');
$language = 'php';
 
$source = '<?php
include(\'language.php\');
include(\'functions.php\');

echo db_exec (\'INSERT\', \'main\', \'30\', array(
	\'make\'	=> \'make test\',
	\'model\'	=> \'model test\'
));
?>';
 
$geshi =& new GeSHi($source, $language);
echo $geshi->parse_code();
?>

<p>Clés de langue (language.php):</p>
<?php
$source = '<?php
$lang = array(
	\'DB_NOACCESS\'	=> \'Error username or password for database connect\',
	\'DB_NOCONNECT\'	=> \'Error connect to database\',
	\'DB_SQLERROR\'	=> \'Error SQL: %s<br />Contact your Administrator\'
);
?>';

$geshi =& new GeSHi($source, $language);
echo $geshi->parse_code();
?>

<p>Fonctions (functions.php):</p>
<?php
$source = '<?php
/*******************
** Functions File **
*******************/

// Connect to Database
function connect ($dbhost, $dbuser, $dbpass, $dbselect) {
	$dbconnect = mysql_connect($dbhost, $dbuser, $dbpass) OR DIE ($lang[\'DB_NOACCESS\']);
	mysql_select_db($dbselect, $dbconnect) OR DIE ($lang[\'DB_NOCONNECT\']);
}

function db_exec ($type, $table, $id=0, $element=array()) {
	global $lang;

	switch ($type) {
		case \'INSERT\':
			$j = sizeof($element);
			$i = 0;
			$sql = "INSERT INTO " . $table . "(";
			foreach ($element as $key => $sub) {
				$sql .= ($nb = $i) ? $key . \') VALUES(\' : $key . \', \';
				$i++;
			}
			$j = sizeof($element);
			$i = 0;
			foreach ($element as $key => $sub) {
				$sql .= ($nb = $i) ? "\'" . $sub . "\')" : "\'" . $sub . "\', ";
				$i++;
			}
			mysql_query($sql) OR DIE (sprintf($lang[\'DB_SQLERROR\'], mysql_error()));
			//OR DIE (mysql_error());
		break;

		case \'DELETE\':
			mysql_query("DELETE FROM " . $table . " WHERE id=" . $id)
				or die (sprintf($lang[\'DB_SQLERROR\'], mysql_error()));
		break;

		case \'SELECT\':
			mysql_query("SELECT " . (($element) ? $element : \'*\') . "
				FROM " . $table . " WHERE id=" . $id)
				or die (sprintf($lang[\'DB_SQLERROR\'], mysql_error()));
		break;

		case \'UPDATE\':
			$j = sizeof($element);
			$i = 0;
			$sql = "UPDATE " . $table . " SET ";
			foreach ($element as $key => $sub) {
				$sql .= ($nb = $i) ? $key . " = \'" . $sub . "\' " : $key . " = \'" . $sub . "\', ";
				$i++;
			}
			$sql .= "WHERE id = " . $id;
		break;
	}
	return $sql;
}

?>';

$geshi =& new GeSHi($source, $language);
echo $geshi->parse_code();
?>

<h3>Liens vers mes créations:</h3>
<p>Au cours de mon apprentissage personnel de ces langages (n'ayant pour le moment pas suivi de formation particulière), j'ai créé et testé toutes sortes de scripts pour faire
vivre mon site internet communautaire (Finitia-World). En voici quelque uns:</p>
<ul>
	<li><a href="http://www.finitia-world.com/Nyxvord/forums/viewtopic.php?f=2&amp;t=9">Projet Nyxvord: Gestionnaire de contenu pour phpBB</a></li>
	<li><a href="http://www.finitia-world.com/labo/planning_schimmel/">Planning du Schimmel de Masevaux (Milieu Hospitalier)</a></li>
	<li><a href="./ressources/fonction_recursive.php">Fonctions récursives</a></li>
	<li>UserBar pour les joueurs</li>
	<li>Analyseur de chaines (<a href="./ressources/RapportStage2011-ComputerJunction.zip">Cliquez-ici pour consulter mon rapport de stage sur le sujet</a>)</li>
</ul>